/*=========================================================================

  Library   : Image Registration Toolkit (IRTK)
  Module    : $Id$
  Copyright : Imperial College, Department of Computing
              Visual Information Processing (VIP), 2008 onwards
  Date      : $Date$
  Version   : $Revision$
  Changes   : $Author$

=========================================================================*/

#ifndef _IRTKGEOMETRY_H

#define _IRTKGEOMETRY_H

#include <irtkCommon.h>

// Scalar functions
#include <irtkScalarFunction.h>

// Complex functions
#include <irtkComplexFunction.h>

// Vectors and matrices
#include <irtkVector.h>
#include <irtkMatrix.h>

// Points and point sets
#include <irtkPoint.h>
#include <irtkPointSet.h>

// VTK functions
#include <irtkVTKFunctions.h>

// Offsets for a neighbourhood mask
#include <irtkNeighbourhoodOffsets.h>

#endif
